diff --git a/src/main/java/net/minecraft/core/block/BlockGravel.java b/src/main/java/net/minecraft/core/block/GravelBlock.java
similarity index 63%
rename from src/main/java/net/minecraft/core/block/BlockGravel.java
rename to src/main/java/net/minecraft/core/block/GravelBlock.java
index fb7135334..03b1421f3 100644
--- a/src/main/java/net/minecraft/core/block/BlockGravel.java
+++ b/src/main/java/net/minecraft/core/block/GravelBlock.java
@@ -1,26 +1,24 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-import java.util.Random;
-
 // Referenced classes of package net.minecraft.src:
-//            BlockSand, Item
+//            SandBlock, Item
 
-public class BlockGravel extends BlockSand
+public class GravelBlock extends SandBlock
 {
 
-    public BlockGravel(String key, int id)
+    public GravelBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -28,7 +26,7 @@ public class BlockGravel extends BlockSand
             case SILK_TOUCH:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                if (world.rand.nextInt(10) == 0) return new ItemStack[] { new ItemStack(Item.flint) };
+                if (world.rand.nextInt(10) == 0) return new ItemStack[] { new ItemStack(Items.FLINT) };
                 else return new ItemStack[] { new ItemStack(this) };
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockIce.java b/src/main/java/net/minecraft/core/block/IceBlock.java
similarity index 61%
rename from src/main/java/net/minecraft/core/block/BlockIce.java
rename to src/main/java/net/minecraft/core/block/IceBlock.java
index 5c0a46d18..918c89d05 100644
--- a/src/main/java/net/minecraft/core/block/BlockIce.java
+++ b/src/main/java/net/minecraft/core/block/IceBlock.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
@@ -12,26 +12,26 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockBreakable, Material, World, Block, 
-//            EnumSkyBlock, IBlockAccess, EntityPlayer
+//            EnumSkyBlock, IBlockAccess, Player
 
-public class BlockIce extends BlockTransparent
+public class IceBlock extends TransparentBlock
 {
 
-    public BlockIce(String key, int id)
+    public IceBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.ice);
-        movementScale = 0.98F;
+        super(key, namespaceId, id, Material.ice);
+        friction = 0.98F;
         setTicking(true);
     }
 
     @Override
-    public int getRenderBlockPass()
+    public int getRenderLayer()
     {
         return 1;
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -44,13 +44,13 @@ public class BlockIce extends BlockTransparent
     }
 
     @Override
-    public void harvestBlock(World world, EntityPlayer entityplayer, int i, int j, int k, int meta, TileEntity tileEntity)
+    public void harvestBlock(World world, Player entityplayer, int i, int j, int k, int meta, BlockEntity blockEntity)
     {
-        super.harvestBlock(world, entityplayer, i, j, k, meta, tileEntity);
+        super.harvestBlock(world, entityplayer, i, j, k, meta, blockEntity);
         Material material = world.getBlockMaterial(i, j - 1, k);
         if(material.blocksMotion() || material.isLiquid())
         {
-            world.setBlockWithNotify(i, j, k, Block.fluidWaterFlowing.id);
+            world.setBlockWithNotify(i, j, k, Blocks.FLUID_WATER_FLOWING.id);
         }
     }
 
@@ -59,7 +59,7 @@ public class BlockIce extends BlockTransparent
     {
         if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11 - Block.lightBlock[id])
         {
-            world.setBlockWithNotify(x, y, z, Block.fluidWaterStill.id);
+            world.setBlockWithNotify(x, y, z, Blocks.FLUID_WATER_STILL.id);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockOreCoal.java b/src/main/java/net/minecraft/core/block/IronOreBlock.java
similarity index 50%
rename from src/main/java/net/minecraft/core/block/BlockOreCoal.java
rename to src/main/java/net/minecraft/core/block/IronOreBlock.java
index 14a7a3c2a..e46cadc8c 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreCoal.java
+++ b/src/main/java/net/minecraft/core/block/IronOreBlock.java
@@ -1,25 +1,25 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, Item
+import java.util.HashMap;
+import java.util.Map;
 
-public class BlockOreCoal extends Block
+public class IronOreBlock extends Block
 {
-
-    public BlockOreCoal(String key, int id)
-    {
-        super(key, id, Material.stone);
+    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public IronOreBlock(String key, String namespaceId, int id, int parentID, Material material) {
+        super(key, namespaceId, id, material);
+        variantMap.put(parentID, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -28,9 +28,10 @@ public class BlockOreCoal extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.coal) };
+                return new ItemStack[] { new ItemStack(Items.ORE_RAW_IRON) };
             default:
                 return null;
         }
     }
+
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockJar.java b/src/main/java/net/minecraft/core/block/JarBlock.java
similarity index 77%
rename from src/main/java/net/minecraft/core/block/BlockJar.java
rename to src/main/java/net/minecraft/core/block/JarBlock.java
index 09b8681c1..df15ce8e5 100644
--- a/src/main/java/net/minecraft/core/block/BlockJar.java
+++ b/src/main/java/net/minecraft/core/block/JarBlock.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityFlowerJar;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.FlowerJarBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.item.block.BlockItem;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
@@ -17,12 +17,12 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public class BlockJar extends BlockTileEntity{
+public class JarBlock extends EntityBlock {
 
     public Item item;
     private final Supplier<Item> itemSupplier;
-    public BlockJar(String key, int id, @NotNull Supplier<Item> itemSupplier) {
-        super(key, id, Material.glass);
+    public JarBlock(String key, String namespaceId, int id, @NotNull Supplier<Item> itemSupplier) {
+        super(key, namespaceId, id, Material.glass);
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
         this.itemSupplier = itemSupplier;
     }
@@ -47,7 +47,7 @@ public class BlockJar extends BlockTileEntity{
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float offset = 0.0F;
-        return AABB.getBoundingBoxFromPool(x + 0.3125f, y + offset, z + 0.3125f, x + 1 - 0.3125f, (float) y + 0.375f + offset, z + 1 - 0.3125f);
+        return AABB.getTemporaryBB(x + 0.3125f, y + offset, z + 0.3125f, x + 1 - 0.3125f, (float) y + 0.375f + offset, z + 1 - 0.3125f);
     }
     @Override
     public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
@@ -66,12 +66,12 @@ public class BlockJar extends BlockTileEntity{
         maxZ = aabb.maxZ - z;
     }
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if(player.getHeldItem() == null) {
             if (world.getBlockMetadata(x, y, z) == 0) {
@@ -81,7 +81,7 @@ public class BlockJar extends BlockTileEntity{
                     world.dropItem(x, y, z, new ItemStack(item, 1, 0));
                 }
             } else {
-                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockTileEntity(x, y, z);
+                FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
                 int flowerInPot = tileEntity.flowerInPot;
                 if (flowerInPot > 0 && hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
                     tileEntity.flowerInPot = 0;
@@ -92,11 +92,11 @@ public class BlockJar extends BlockTileEntity{
                     }
                 }
             }
-        } else if (world.getBlockMetadata(x, y, z) == 0 && player.getHeldItem().getItem() instanceof ItemBlock) {
-            Block blockInHand = ((ItemBlock) player.getHeldItem().getItem()).getBlock();
+        } else if (world.getBlockMetadata(x, y, z) == 0 && player.getHeldItem().getItem() instanceof BlockItem) {
+            Block blockInHand = ((BlockItem) player.getHeldItem().getItem()).getBlock();
             if(hasTag(blockInHand.id, BlockTags.PLANTABLE_IN_JAR)){
                 player.getHeldItem().consumeItem(player);
-                TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockTileEntity(x, y, z);
+                FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
                 world.setBlockMetadataWithNotify(x, y, z, 1);
                 tileEntity.flowerInPot = blockInHand.id;
             }
@@ -105,7 +105,7 @@ public class BlockJar extends BlockTileEntity{
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -120,7 +120,7 @@ public class BlockJar extends BlockTileEntity{
 
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
-        TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockTileEntity(x, y, z);
+        FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
         int flowerInPot = tileEntity.flowerInPot;
         if (flowerInPot > 0 && hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
             tileEntity.flowerInPot = 0;
@@ -138,9 +138,9 @@ public class BlockJar extends BlockTileEntity{
     }
 
     @Override
-    protected TileEntity getNewBlockEntity()
+    protected BlockEntity getNewBlockEntity()
     {
-        return new TileEntityFlowerJar();
+        return new FlowerJarBlockEntity();
     }
 
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/BlockJukeBox.java b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
similarity index 63%
rename from src/main/java/net/minecraft/core/block/BlockJukeBox.java
rename to src/main/java/net/minecraft/core/block/JukeboxBlock.java
index 4d2c5b06e..6617e90d1 100644
--- a/src/main/java/net/minecraft/core/block/BlockJukeBox.java
+++ b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
@@ -1,28 +1,28 @@
 package net.minecraft.core.block;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockContainer, Material, World, TileEntityRecordPlayer, 
-//            EntityItem, ItemStack, EntityPlayer, TileEntity
+//            BlockContainer, Material, World, JukeboxBlockEntity,
+//            ItemEntity, ItemStack, Player, BlockEntity
 
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.JukeboxBlockEntity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityRecordPlayer;
 import net.minecraft.core.block.material.Material;
 
-public class BlockJukeBox extends BlockTileEntity
+public class JukeboxBlock extends EntityBlock
 {
 
-	public BlockJukeBox(String key, int id)
+	public JukeboxBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.wood);
+        super(key, namespaceId, id, Material.wood);
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if(world.getBlockMetadata(x, y, z) == 0)
         {
@@ -37,9 +37,9 @@ public class BlockJukeBox extends BlockTileEntity
     public void playRecord(World world, int i, int j, int k, int l)
     {
         if (!world.isClientSide) {
-            TileEntityRecordPlayer tileentityrecordplayer = (TileEntityRecordPlayer) world.getBlockTileEntity(i, j, k);
+            JukeboxBlockEntity tileentityrecordplayer = (JukeboxBlockEntity) world.getBlockEntity(i, j, k);
             tileentityrecordplayer.record = l;
-            tileentityrecordplayer.onInventoryChanged();
+            tileentityrecordplayer.setChanged();
             world.setBlockMetadataWithNotify(i, j, k, 1);
         }
     }
@@ -50,21 +50,21 @@ public class BlockJukeBox extends BlockTileEntity
         {
             return;
         }
-        TileEntityRecordPlayer tileentityrecordplayer = (TileEntityRecordPlayer)world.getBlockTileEntity(i, j, k);
+        JukeboxBlockEntity tileentityrecordplayer = (JukeboxBlockEntity)world.getBlockEntity(i, j, k);
         int l = tileentityrecordplayer.record;
         if (l != 0) {
             world.playSoundEffect(1005, i, j, k, 0);
             world.playRecord(null, null, i, j, k);
             tileentityrecordplayer.record = 0;
-            tileentityrecordplayer.onInventoryChanged();
+            tileentityrecordplayer.setChanged();
             world.setBlockMetadataWithNotify(i, j, k, 0);
             int i1 = l;
             float f = 0.7F;
             double d = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
             double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.2D + 0.6D;
             double d2 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            EntityItem entityitem = new EntityItem(world, (double) i + d, (double) j + d1, (double) k + d2, new ItemStack(i1, 1, 0));
-            entityitem.delayBeforeCanPickup = 10;
+            ItemEntity entityitem = new ItemEntity(world, (double) i + d, (double) j + d1, (double) k + d2, new ItemStack(i1, 1, 0));
+            entityitem.pickupDelay = 10;
             world.entityJoinedWorld(entityitem);
         }
     }
@@ -77,8 +77,8 @@ public class BlockJukeBox extends BlockTileEntity
     }
 
     @Override
-	protected TileEntity getNewBlockEntity()
+	protected BlockEntity getNewBlockEntity()
     {
-        return new TileEntityRecordPlayer();
+        return new JukeboxBlockEntity();
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockLadder.java b/src/main/java/net/minecraft/core/block/LadderBlock.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/BlockLadder.java
rename to src/main/java/net/minecraft/core/block/LadderBlock.java
index 5bc47b755..5ee6eda1f 100644
--- a/src/main/java/net/minecraft/core/block/BlockLadder.java
+++ b/src/main/java/net/minecraft/core/block/LadderBlock.java
@@ -7,10 +7,10 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockLadder extends Block {
+public class LadderBlock extends Block {
 
-	public BlockLadder(String key, int id) {
-		super(key, id, Material.wood);
+	public LadderBlock(String key, String namespaceId, int id) {
+		super(key, namespaceId, id, Material.wood);
 	}
 	
 	@Override
@@ -19,7 +19,7 @@ public class BlockLadder extends Block {
 	}
 	
 	@Override
-	public boolean renderAsNormalBlock() {
+	public boolean isCubeShaped() {
 		return false;
 	}
 
@@ -55,13 +55,13 @@ public class BlockLadder extends Block {
 	
 	@Override
 	public final boolean canPlaceBlockAt(World world, int x, int y, int z) {
-		// Unused, check ItemBlockLadder
+		// Unused, check LadderBlockItem
 		return true;
 	}
 	
 	@Override
-	public final boolean canPlaceBlockOnSide(World world, int x, int y, int z, int side) {
-		// Unused, check ItemBlockLadder
+	public final boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side) {
+		// Unused, check LadderBlockItem
 		return true;
 	}
 	
diff --git a/src/main/java/net/minecraft/core/block/BlockLamp.java b/src/main/java/net/minecraft/core/block/LampBlock.java
similarity index 55%
rename from src/main/java/net/minecraft/core/block/BlockLamp.java
rename to src/main/java/net/minecraft/core/block/LampBlock.java
index b7fafe3c4..9b5350105 100644
--- a/src/main/java/net/minecraft/core/block/BlockLamp.java
+++ b/src/main/java/net/minecraft/core/block/LampBlock.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -8,29 +8,25 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockLamp extends Block
+public class LampBlock extends Block
 {
-    public BlockLamp(String key, int id, boolean isActivated) {
-        super(key, id, Material.stone);
+    public LampBlock(String key, String namespaceId, int id, boolean isActivated) {
+        super(key, namespaceId, id, Material.stone);
         isActive = isActivated;
         setTicking(true);
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
         return 2;
     }
     
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
-        world.scheduleBlockUpdate(x, y, z, id, tickRate());
-    }
-    public static int getMetadataForColour(int i)
-    {
-        return ~i & 0xf;
+        super.onBlockPlacedByWorld(world, x, y, z);
+        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
     }
 
     @Override
@@ -40,24 +36,24 @@ public class BlockLamp extends Block
         if(isActive)
         {
             if(!isPoweredByBlock)
-                world.setBlockAndMetadataWithNotify(x, y, z, Block.lampIdle.id, world.getBlockMetadata(x, y, z));
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id, world.getBlockMetadata(x, y, z));
         } else
         if(isPoweredByBlock)
         {
-            world.setBlockAndMetadataWithNotify(x, y, z, Block.lampActive.id, world.getBlockMetadata(x, y, z));
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id, world.getBlockMetadata(x, y, z));
         }
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        world.scheduleBlockUpdate(x, y, z, id, tickRate());
+        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        return new ItemStack[] { new ItemStack(Block.lampIdle, 1, meta) };
+        return new ItemStack[] { new ItemStack(Blocks.LAMP_IDLE, 1, meta) };
     }
 
     public boolean isActive;
diff --git a/src/main/java/net/minecraft/core/block/BlockOreLapis.java b/src/main/java/net/minecraft/core/block/LapisOreBlock.java
similarity index 50%
rename from src/main/java/net/minecraft/core/block/BlockOreLapis.java
rename to src/main/java/net/minecraft/core/block/LapisOreBlock.java
index f96f7ed3e..c02b586ab 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreLapis.java
+++ b/src/main/java/net/minecraft/core/block/LapisOreBlock.java
@@ -1,25 +1,26 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, Item
+import java.util.HashMap;
+import java.util.Map;
 
-public class BlockOreLapis extends Block
+public class LapisOreBlock extends Block
 {
-
-    public BlockOreLapis(String key, int id)
+    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public LapisOreBlock(String key, String namespaceId, int id, int parentId, Material material)
     {
-        super(key, id, Material.stone);
+        super(key, namespaceId, id, material);
+        variantMap.put(parentId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -28,7 +29,7 @@ public class BlockOreLapis extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.dye, 4 + world.rand.nextInt(5), 4) };
+                return new ItemStack[] { new ItemStack(Items.DYE, 4 + world.rand.nextInt(5), 4) };
             default:
                 return null;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java b/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
similarity index 88%
rename from src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
rename to src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
index faefd92a3..74473f4b3 100644
--- a/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
+++ b/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.EntityLiving;
+
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
@@ -14,16 +13,16 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
-//            IBlockAccess, Item, EntityItem, ItemStack, 
-//            StatList, EntityPlayer, EnumSkyBlock
+//            IBlockAccess, Item, ItemEntity, ItemStack,
+//            StatList, Player, EnumSkyBlock
 
-public class BlockLayerLeaves extends BlockLayerBase
+public class LeavesLayerBlock extends BaseLayerBlock
 {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
-	public BlockLayerLeaves(String key, int id, Material material)
+	public LeavesLayerBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         setTicking(true);
     }
@@ -56,7 +55,7 @@ public class BlockLayerLeaves extends BlockLayerBase
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BlockLeavesBase)))
+        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BaseLeavesBlock)))
         {
         	return false;
         }
@@ -87,7 +86,7 @@ public class BlockLayerLeaves extends BlockLayerBase
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
